#ifdef _DEBUG
	#pragma comment( lib, "cv210d.lib" )
	#pragma comment( lib, "cxcore210d.lib" )
	#pragma comment( lib, "cvaux210d.lib" )
	#pragma comment( lib, "highgui210d.lib" )
#else
	#pragma comment( lib, "cv210.lib" )
	#pragma comment( lib, "cxcore210.lib" )
	#pragma comment( lib, "cvaux210.lib" )
	#pragma comment( lib, "highgui210.lib" )
#endif

#include <cv.h>
#include <cxcore.h>
#include <highgui.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include <iostream>

// mIHoughϊp邩ǂ
#define	PROB

int main( int argc, char** argv )
{
	const std::string		windowNameSrc = "Source (in Grayscale)";
	const std::string		windowNameEdge = "Edge by Canny";
	const std::string		windowNameDst = "Detected Lines";

	// 摜̓ǂݍ݁Co͂i[邽߂Matǉ
	cv::Mat	src = cv::imread( std::string( ".\\input.jpg" ), CV_LOAD_IMAGE_GRAYSCALE );
	cv::Mat	edge;
	cv::Mat	dst = cv::imread( std::string( ".\\input.jpg" ) );
	const double	rho = 1;
	const double	theta = CV_PI / 180;
	const int		thres = 80;

	// ͉摜̃GbWƂiCannytB^pj
	cv::Canny( src, edge, 50, 200, 3 );

#ifdef	PROB
	std::cout << "Probablistic Hough Transformation" << std::endl;
	cv::vector<cv::Vec4i>	lines;
	// mIHoughϊs
	cv::HoughLinesP( edge, lines, rho, theta, thres, 50, 10 );

	// oʂ`
	for( int i = 0; i < lines.size(); i++ ) {
		cv::line( dst, cv::Point( lines[i][0], lines[i][1] ), cv::Point( lines[i][2], lines[i][3] ), cv::Scalar( 0, 0, 255 ) ); 
	}
#else
	std::cout << "Traditional Hough Transformation" << std::endl;
	cv::vector<cv::Vec2f>	lines;
	// ÓTIHoughϊs
	cv::HoughLines( edge, lines, rho, theta, thres );

	// oꂽ͋ɍWnŊi[Ă̂ŁCWɖ߂ĕ`
	double	a, b, x0, y0;
	cv::Point pt1, pt2;

	for( int i = 0; i < lines.size(); i++ ) {
		float rho = lines[i][0];
		float theta = lines[i][1];

		a = cos(lines[i][1]);
		b = sin(lines[i][1]);
		x0 = a * lines[i][0];
		y0 = b * lines[i][0];
		
		pt1 = cv::Point( cvRound( x0 + 1000 * ( -b ) ), cvRound( y0 + 1000 * a ) );
		pt2 = cv::Point( cvRound( x0 - 1000 * ( -b ) ), cvRound( y0 - 1000 * a ) );
		cv::line( dst, pt1, pt2, cv::Scalar( 0, 0, 255 ) );
	}
#endif

	// EChE쐬ĕ\
	cv::namedWindow( windowNameSrc );
	cv::namedWindow( windowNameEdge );
	cv::namedWindow( windowNameDst );
	cv::imshow( windowNameSrc, src );
	cv::imshow( windowNameEdge, edge );
	cv::imshow( windowNameDst, dst );
	cv::waitKey( 0 );

    return 0;
}
